#include <reg552.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <rtx51.h>

#define CNTLQ      0x11
#define CNTLS      0x13
#define DEL        0x7F
#define BACKSPACE  0x08
#define CR         0x0D
#define LF         0x0A

char getkey(void)
{
 while(!RI) os_wait(K_TMO,0x00,NULL);
 RI=0;
 return(S0BUF);
}

char putchar(char ch)
{
 S0BUF=ch;
 while(!TI) os_wait(K_TMO,0x00,NULL);
 TI=0;
 return(ch);
}
/*
void getline (char xdata *line, unsigned char n)  
{
  unsigned char cnt = 0;
  char c;
  do  
	{
		if ((c = getkey ()) == CR)  c = LF;    	
    if (c == BACKSPACE  ||  c == DEL)  
		{    																		
      if (cnt != 0)  
			{            
        cnt--;                             
        line--;                            
        putchar (0x08);                    
        putchar (' ');
        putchar (0x08);
      }
    }
    else if (c != CNTLQ && c != CNTLS)  
		{   																		
      putchar (*line = c);                  
      line++;                               
      cnt++;                                
    }
	 os_wait(K_TMO,0x00,NULL);	
  }  
	while (cnt < n - 1  &&  c != LF);      		
  *line = 0;                                
}
*/
void Init_Serial(void)
{
 PCON|=0x80;
 S0CON|=0x50;
 TMOD|=0x20;
 TH1=TL1=0xFB;															//19200 bps
 TR1=1;
}